#pragma once

#include <VulcanoLE/Visual/VIZ.h>

namespace VIZ {
    class RainbowMap : public VIZ {
        int currentColumn = 0;
        double deltaNeeded = 100000.0;
        double deltaElapsed = 0;
        rgba *colours = nullptr;
        int maxCols = 0;
        double lastValue = 0;
        double decayValue = 0;
    public:
        RainbowMap(AudioGrabber *pGrabber, Vulcan121 *vulcan);
        ~RainbowMap() override;
        void onSetup() override;
        void onTick(float delta) override;
        void calcNextDelta(double ratio);
        const char *name() override;
        std::string m_name = "Rainbow Map";
        led_map data{};
        bool firstUnder = true;
        double deltaMove(double val);
        void moveRainbow(double d);
        void updateColumn(int column, int colIndex);
    };
}